import os

def _init():
    global _global_dict
    _global_dict = {}

def set_value(name, value):
    _global_dict[name] = value

def get_value(name, defValue=None):
    try:
        return _global_dict[name]
    except KeyError:
        return defValue


class ConfigInfo():
    def __init__(self, index):

        self.name = ['consistency_all_512_512_256_1_(9_9_3_3)',]
        self.index = index
        self.data_path = './data'
        
        # training

        self.epochs = 20
        self.pem_epochs = 40
        self.save_path = 'models_{}/'.format(self.name[self.index])

        # dataset

        self.batch = 3
        self.pem_batch = 256
        self.in_window = 3000
        self.out_window = 750
        self.t_granularity = 16 # 16frame/25frame  fps:25frames
        self.t_step = 16 # 4frame/25frame 
        self.down_sample = 4
        self.class_num = 20

        with open(os.path.join(self.data_path, 'videos_fps.txt'), 'r') as f:
            lines = f.readlines()
        self.fps = {}
        for line in lines:
            tmp = line.strip().split()
            self.fps[tmp[0]] = float(tmp[1])

        # model
        
        settings = [[512,9,1,256,3,1],]

        self.mode = self.name[self.index].split('_')[0]

        self.base_c = settings[self.index][0]
        self.base_k = settings[self.index][1]
        self.base_d = settings[self.index][2]

        self.part_c = settings[self.index][3]
        self.part_k = settings[self.index][4]
        self.part_d = settings[self.index][5]
