import sys
sys.path.append('./Evaluation')
from eval_detection import ANETdetection
import matplotlib.pyplot as plt
import numpy as np
from tqdm import tqdm
import ipdb

def run_evaluation(ground_truth_filename, prediction_filename, 
                   tiou_thresholds=np.linspace(0.1, 0.9, 9),
                   subset='test'):

    anet_detection = ANETdetection(ground_truth_filename, prediction_filename,
                                 tiou_thresholds=tiou_thresholds,
                                 subset=subset, verbose=True, check_status=False)
    anet_detection.evaluate()
    
    ap = anet_detection.ap
    mAP = anet_detection.mAP
    
    return mAP




if __name__ == '__main__':
    # eval_file="./Evaluation/data/results_score_ase.json"
    eval_file = "eval_file_path"

    mAP = run_evaluation(
        "./Evaluation/data/thumos14.json",
        eval_file,
        tiou_thresholds=np.linspace(0.1, 0.9, 9),
        subset='test')

    print mAP

